## START: Set by rpmautospec
## (rpmautospec version 0.3.5)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

Name:           oscillatord
Version:        3.5.0
Release:        %autorelease
Summary:        Daemon for disciplining an oscillator

License:        GPLv2+
URL:            https://github.com/Orolia2s/oscillatord
Source0:        %{url}/archive/v%{version}/%{name}-%{version}.tar.gz

BuildRequires:  gcc
BuildRequires:  cmake
BuildRequires:  gpsd-devel
BuildRequires:  json-c-devel
BuildRequires:  liboscillator-disciplining-devel >= %{version}
BuildRequires:  pps-tools-devel
BuildRequires:  sed
BuildRequires:  systemd
BuildRequires:  systemd-devel
BuildRequires:  systemd-rpm-macros
BuildRequires:  ubloxcfg-devel >= 1.13-1.20220420gita46d97c

Requires: liboscillator-disciplining = %{version}
Requires: ubloxcfg >= 1.13-1.20220420gita46d97c

%description
The oscillatord daemon takes input from a PHC clock, reporting once per second,
the phase error between an oscillator and a reference GNSS receiver. For an
example of such a device, please see the ptp_ocp kernel driver.

The phase error read is then used as an input to the disciplining-minipod
library which will compute a setpoint, used by oscillatord to control an
oscillator and discipline it to the 1PPS from a GNSS receiver. Oscillatord also
sets PHC'stime at start up, using Output from a GNSS receiver.

To communicate with GNSS receiver's serial it uses ubloxcfg

%prep
%autosetup
# Fix paths in systemd unit
sed -e 's/^Environment=LD_LIBRARY_PATH.*$//' \
    -e "s@/usr/local/bin@%{_bindir}@" \
    -i systemd/oscillatord.service
# Drop hardcoded CFLAGS
sed -e 's/-O0//g' -i CMakeLists.txt

%build
%cmake -DBUILD_UTILS=1
%cmake_build

%install
%cmake_install

# install default config
install -Dpm0644 example_configurations/%{name}_default.conf \
    %{buildroot}%{_sysconfdir}/%{name}.conf

%post
%systemd_post oscillatord.service

%preun
%systemd_preun oscillatord.service

%postun
%systemd_postun_with_restart oscillatord.service

%files
%license LICENSE
%doc README.md example_configurations
%{_bindir}/*
%{_unitdir}/%{name}.service
%config(noreplace) %{_sysconfdir}/%{name}.conf
%exclude %{_unitdir}/%{name}@.service

%changelog
* Tue Feb 21 2023 Oleg Obleukhov <leoleovich@fedoraproject.org> - 3.5.0-1
- Update to 3.5.0

* Tue Feb 14 2023 Oleg Obleukhov <leoleovich@fedoraproject.org> - 3.4.5-1
- Update to 3.4.5

* Thu Jan 19 2023 Fedora Release Engineering <releng@fedoraproject.org> - 3.4.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Wed Jan 11 2023 Alexander Bulimov <abulimov@fedoraproject.org> - 3.4.3-1
- Update to 3.4.3

* Tue Jan 03 2023 Alexander Bulimov <abulimov@fedoraproject.org> - 3.4.2-3
- Drop C99 patch that was merged upstream

* Tue Jan 03 2023 Oleg Obleukhov <leoleovich@gmail.com> - 3.4.2-2
- RPMAUTOSPEC: unresolvable merge
